Oracle Coherence for C++ API
Release 3.6.1.0
E18813-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CompositeAggregator Class Reference

`#include <coherence/util/aggregator/CompositeAggregator.hpp>`

Inherits Object, PortableObject, and InvocableMap::EntryAggregator.

Inherited by ParallelCompositeAggregator.

List of all members.

## Detailed Description

CompositeAggregator provides an ability to execute a collection of aggregators against the same subset of the entries in an InvocableMap, resulting in a list of corresponding aggregation results.

The size of the returned list will always be equal to the length of the aggregators' array.

Author:
  djl 2008.05.16

## Public Types
typedef spec::Handle | Handle
| CompositeAggregator Handle definition.
typedef spec::View | View
| CompositeAggregator View definition.
typedef spec::Holder | Holder
| CompositeAggregator Holder definition.
## Public Member Functions
virtual Object::Holder | aggregate (Set::View vSetEntries)
  | Process a set of InvocableMap::Entry objects in order to produce an aggregated result. Parameters:
  | vSetEntries | a Set of read-only InvocableMap::Entry objects to aggregate
Returns: the aggregated result from processing the entries
virtual void | readExternal (PofReader::Handle hIn)
virtual void | writeExternal (PofWriter::Handle hOut) const
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual ObjectArray::View | getAggregators () const
| Determine the ValueExtractor whose values this aggregator is aggregating.
## Static Public Member Functions
static CompositeAggregator::Handle | create ()
| Default constructor (necessary for the PortableObject interface).
static CompositeAggregator::Handle | create (ObjectArray::View vaAggregator)
| Create an instance of CompositeAggregator based on a specified array of coherence::util::InvocableMap::EntryAggregator.
## Protected Attributes
MemberView< ObjectArray > | m_vaAggregator
| The underlying EntryAggregator array.

## Member Function Documentation

static CompositeAggregator::Handle create | ( | ObjectArray::View | vaAggregator | ) | `[static]`

Create an instance of CompositeAggregator based on a specified array of coherence::util::InvocableMap::EntryAggregator.

If all the aggregators in the specified array are instances of coherence::util::InvocableMap::ParallelAwareAggregator then a parallel-aware instance of the CompositeAggregator will be created.
If at least one of the specified aggregator is not parallel-aware, then the resulting CompositeAggregator will not be parallel-aware and could be ill-suited for aggregations run against large partitioned caches.

Parameters:

  | vaAggregator | an array of EntryAggregator objects; must contain not less than two aggregators

virtual ObjectArray::View getAggregators | ( |  | ) | const `[virtual]`

Determine the ValueExtractor whose values this aggregator is aggregating.

Returns:
  the ValueExtractor used by this aggregator

The documentation for this class was generated from the following file:

- coherence/util/aggregator/CompositeAggregator.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.